Signature
Date: 2016-06-24

java.security

## Class Signature

- java.lang.Object
- - java.security.SignatureSpi
  - - java.security.Signature

-     public abstract class Signature
      extends SignatureSpi

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static int` | `SIGN`
    `protected int` | `state`
    `protected static int` | `UNINITIALIZED`
    `protected static int` | `VERIFY`

    - ### Fields inherited from class java.security.SignatureSpi

      `appRandom`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Signature(String var0)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getAlgorithm()`
    `static Signature` | `getInstance(String var0)`
    `static Signature` | `getInstance(String var0, Provider var1)`
    `static Signature` | `getInstance(String var0, String var1)`
    `AlgorithmParameters` | `getParameters()`
    `Provider` | `getProvider()`
    `void` | `initSign(PrivateKey var0)`
    `void` | `initSign(PrivateKey var0, SecureRandom var1)`
    `void` | `initVerify(Certificate var0)`
    `void` | `initVerify(PublicKey var0)`
    `void` | `setParameter(AlgorithmParameterSpec var0)`
    `byte[]` | `sign()`
    `int` | `sign(byte[] var0, int var1, int var2)`
    `void` | `update(byte var0)`
    `void` | `update(byte[] var0)`
    `void` | `update(byte[] var0, int var1, int var2)`
    `boolean` | `verify(byte[] var0)`
    `boolean` | `verify(byte[] var0, int var1, int var2)`

    - ### Methods inherited from class java.security.SignatureSpi

      `clone, engineGetParameters, engineInitSign, engineInitSign, engineInitVerify, engineSetParameter, engineSign, engineSign, engineUpdate, engineUpdate, engineVerify, engineVerify`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SIGN

          protected static final int SIGN

      See Also:
        Constant Field Values

    - #### UNINITIALIZED

          protected static final int UNINITIALIZED

      See Also:
        Constant Field Values

    - #### VERIFY

          protected static final int VERIFY

      See Also:
        Constant Field Values

    - #### state

          protected int state

  - ### Constructor Detail

    - #### Signature

          protected Signature(String var0)

  - ### Method Detail

    - #### getAlgorithm

          public final String getAlgorithm()

    - #### getInstance

          public static Signature getInstance(String var0)
                                       throws NoSuchAlgorithmException

      Throws:
        `NoSuchAlgorithmException`

    - #### getInstance

          public static Signature getInstance(String var0,
                              String var1)
                                       throws NoSuchAlgorithmException,
                                              NoSuchProviderException

      Throws:
        `NoSuchAlgorithmException`
        `NoSuchProviderException`

    - #### getInstance

          public static Signature getInstance(String var0,
                              Provider var1)
                                       throws NoSuchAlgorithmException

      Throws:
        `NoSuchAlgorithmException`

    - #### getParameters

          public final AlgorithmParameters getParameters()

    - #### getProvider

          public final Provider getProvider()

    - #### initSign

          public final void initSign(PrivateKey var0)
                              throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### initSign

          public final void initSign(PrivateKey var0,
                      SecureRandom var1)
                              throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### initVerify

          public final void initVerify(PublicKey var0)
                                throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### initVerify

          public final void initVerify(Certificate var0)
                                throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### setParameter

          public final void setParameter(AlgorithmParameterSpec var0)
                                  throws InvalidAlgorithmParameterException

      Throws:
        `InvalidAlgorithmParameterException`

    - #### sign

          public final byte[] sign()
                            throws SignatureException

      Throws:
        `SignatureException`

    - #### sign

          public final int sign(byte[] var0,
                 int var1,
                 int var2)
                         throws SignatureException

      Throws:
        `SignatureException`

    - #### update

          public final void update(byte var0)
                            throws SignatureException

      Throws:
        `SignatureException`

    - #### update

          public final void update(byte[] var0)
                            throws SignatureException

      Throws:
        `SignatureException`

    - #### update

          public final void update(byte[] var0,
                    int var1,
                    int var2)
                            throws SignatureException

      Throws:
        `SignatureException`

    - #### verify

          public final boolean verify(byte[] var0)
                               throws SignatureException

      Throws:
        `SignatureException`

    - #### verify

          public final boolean verify(byte[] var0,
                       int var1,
                       int var2)
                               throws SignatureException

      Throws:
        `SignatureException`